/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 4, 2007   Ҳڹ()    Class ó ۼ  
 * Aug 12, 2007  Ҳڹ()    LookAndFeel   
 * Sep 15, 2007  Ҳڹ()    ý ũ   κ SystemProperties util  
 *************************************************************************
 */

package com.nate.hjy7942.conf.manager;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.UIManager;

import org.w3c.dom.NodeList;

import com.l2fprod.gui.plaf.skin.Skin;
import com.l2fprod.gui.plaf.skin.SkinLookAndFeel;
import com.nate.hjy7942.conf.reader.LoggerReader;
import com.nate.hjy7942.conf.reader.PropertiesReader;
import com.nate.hjy7942.conf.reader.XmlReader;
import com.nate.hjy7942.database.DatabaseConnectionManager;
import com.nate.hjy7942.database.IllegalConnectionException;
import com.nate.hjy7942.ui.dialog.WorkspaceLauncherDialog;
import com.nate.hjy7942.ui.maker.FrameComponetMaker;
import com.nate.hjy7942.ui.maker.FrameLayoutMaker;
import com.nate.hjy7942.ui.maker.MenuMaker;
import com.nate.hjy7942.ui.maker.StateBarMaker;
import com.nate.hjy7942.ui.maker.ToolBarMaker;
import com.nate.hjy7942.util.ResourceHandler;
import com.nate.hjy7942.util.SystemProperties;

/**
 * ۼ : Aug 4, 2007
 * ۼ : Ҳڹ()
 * <br>
 * α׷ UI ִ ü.
 */

class FrameConfigManager {

	private MainFrame mainFrame = null;
	private Container con = null;
	
	/**
	 * @param mainFrame FrameConfigManager  θ Frame ӹ ü
	 */
	FrameConfigManager(MainFrame mainFrame){
		this.mainFrame = mainFrame;
	}
	
	/**
	 * Default LookAndFeel  ִ Լ.
	 */
	void setLookAndFeel(){
		String frameFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "frameFile");
		String lookAndFeelName = new PropertiesReader(mainFrame).getPropertyValue(frameFileName, "lookandfeelname");
		
		if(lookAndFeelName.equals("NimRODLF")){
			try{
				UIManager.setLookAndFeel(new com.nilo.plaf.nimrod.NimRODLookAndFeel());
			}catch(Exception ee){
				JOptionPane.showMessageDialog(mainFrame, "LookAndFeel  ߽ϴ.", "", JOptionPane.ERROR_MESSAGE);
				LoggerReader.getLogger(mainFrame).warn("LookAndFeel  ߽ϴ. (" + ee.getMessage() + ")");
			}		
				UIManager.put("Tree.collapsedIcon", ResourceHandler.createImageIcon("plus.png"));
				UIManager.put("Tree.expandedIcon", ResourceHandler.createImageIcon("minus.png"));
		}
		else if(lookAndFeelName.endsWith("skinlf")){
			try{
				Skin theSkinToUse = SkinLookAndFeel.loadThemePack("lib/themepack.zip");
				SkinLookAndFeel.setSkin(theSkinToUse);
				UIManager.setLookAndFeel(new SkinLookAndFeel());
			}catch(Exception e){
				JOptionPane.showMessageDialog(mainFrame, "LookAndFeel  ߽ϴ.", "", JOptionPane.ERROR_MESSAGE);
				LoggerReader.getLogger(mainFrame).warn("LookAndFeel  ߽ϴ. (" + e.getMessage() + ")");
			}
		}
		else if(lookAndFeelName.endsWith("window")){
		    try {
	        	UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
			}catch(Exception e){
				JOptionPane.showMessageDialog(mainFrame, "LookAndFeel  ߽ϴ.", "", JOptionPane.ERROR_MESSAGE);
				LoggerReader.getLogger(mainFrame).warn("LookAndFeel  ߽ϴ. (" + e.getMessage() + ")");
			}
		}
		else{
			JOptionPane.showMessageDialog(mainFrame, "LookAndFeel ̸ ߸ Ǿϴ.", "", JOptionPane.ERROR_MESSAGE);
		}
	}
	
	/**
	 * Frame LookAndFeel, Size, Title  ִ Լ
	 */
	void buildFrame(){
		String frameFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "frameFile");
		String title = new PropertiesReader(mainFrame).getPropertyValue(frameFileName, "title");
		
		mainFrame.setTitle(title);
		Dimension dimension = SystemProperties.getScreenSize();
		mainFrame.setSize((int)dimension.getWidth() - 200, (int)dimension.getHeight() - 200);
		mainFrame.setLocation(SystemProperties.getCenterPoint(mainFrame));
		// mainFrame.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE); 
		mainFrame.addWindowListener(new MainWindowListener());
		con = mainFrame.getContentPane();
		con.setLayout(new BorderLayout());
	}
	
	/**
	 * Frame MenuBar  Menu ִ Լ
	 */
	void buildMenuBar(){
		String xmlMenuBarFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "menuBarFile");
		NodeList menuBarNodeList = new XmlReader(mainFrame).getMenuBarNodeListFromXml(xmlMenuBarFileName);
		new MenuMaker(mainFrame).makeMenuBar(menuBarNodeList);
	}

	/**
	 * Frame ToolBar  ִ Լ
	 */
	void buildToolBar(){
		String xmlToolBarFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "toolBarFile");
		NodeList menuBarNodeList = new XmlReader(mainFrame).getToolBarNodeListFromXml(xmlToolBarFileName);
		new ToolBarMaker(mainFrame).makeToolBar(menuBarNodeList);		
	}
	
	
	/**
	 * Frame Layout  ִ Լ
	 */
	void buildLayout(){
		String frameFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "frameFile");
		
		new FrameLayoutMaker(mainFrame).makeLayout();
	}
	
	/**
	 * Frame ȭ鿡  Component оͼ  ִ Լ
	 */
	void buildComponent(){
		String frameFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "frameFile");
		
		new FrameComponetMaker(mainFrame).makeComponent();
	}
	
	/**
	 * Frame StateBar  ִ Լ
	 */
	void buildStateBar(){
		new StateBarMaker(mainFrame).makeStateBar();		
	}
	
	void loadWorkSpaceInfo(){
		String frameSetupFile = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "frameFile");
		String currentWorkSpase = new PropertiesReader(mainFrame).getPropertyValue(frameSetupFile, "currentworkspase").trim();
		
		if(currentWorkSpase == null || currentWorkSpase == "" || !(new File(currentWorkSpase).isDirectory())){
			while(currentWorkSpase == null || currentWorkSpase == "" || !(new File(currentWorkSpase).isDirectory())){
				currentWorkSpase = WorkspaceLauncherDialog.showDialog(mainFrame);
				if(currentWorkSpase == null || currentWorkSpase == "" || !(new File(currentWorkSpase).isDirectory())){
					JOptionPane.showMessageDialog(mainFrame, " Workspace ΰ ùٸ ʽϴ.\n  ֽʽÿ.", "", JOptionPane.ERROR_MESSAGE);
					continue;
				}
				mainFrame.setWorkSpaceFolder(currentWorkSpase);	
			}
		}
		else{
			mainFrame.setWorkSpaceFolder(currentWorkSpase);
		}
	}
	
	void loadProjectInfo(){
		mainFrame.setCurrentProjectFolder("TestProject");
		mainFrame.setCurrentProjectPlsqlFolder("sql");
		mainFrame.setCurrentProjectJspFolder("jsp");
		
		File projectFolder = new File(mainFrame.getWorkSpaceFolder() + File.separator + mainFrame.getCurrentProjectFolder());
		if(!projectFolder.exists()){
			if(projectFolder.mkdir()){
				File plsqlFolder = new File(mainFrame.getWorkSpaceFolder() + File.separator + mainFrame.getCurrentProjectFolder() +
						File.separator + mainFrame.getCurrentProjectPlsqlFolder());
				if(!plsqlFolder.mkdir()){
					JOptionPane.showMessageDialog(mainFrame, "PL/SQL   ", "", JOptionPane.ERROR_MESSAGE);
				}
				File jspFolder = new File(mainFrame.getWorkSpaceFolder() + File.separator + mainFrame.getCurrentProjectFolder() +
						File.separator + mainFrame.getCurrentProjectJspFolder());
				if(!jspFolder.mkdir()){
					JOptionPane.showMessageDialog(mainFrame, "JavaStoredProcedure   ", "", JOptionPane.ERROR_MESSAGE);
				}			
			}
			else{
				JOptionPane.showMessageDialog(mainFrame, "Project   ", "", JOptionPane.ERROR_MESSAGE);
			}
		}
		else{
			JOptionPane.showMessageDialog(mainFrame, "̹ Ʈ  մϴ.", "", JOptionPane.ERROR_MESSAGE);
		}
	}
	
	private class MainWindowListener extends WindowAdapter {

		@Override
		public void windowClosing(WindowEvent e) {
			try {
				DatabaseConnectionManager.getInstance().close();
			} catch (IllegalConnectionException e1) {
				e1.printStackTrace();
			}
		}

		
	}
}