/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 6, 2007   Ҳڹ()         Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.conf.reader;

import java.awt.Font;
import java.io.File;
import java.io.FileInputStream;

import javax.swing.JOptionPane;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.util.ResourceHandler;


/**
 * ۼ : Aug 6, 2007
 * ۼ : Ҳڹ()
 * <br>
 * Ʈ ü ϱ  ü (Singleton ü)
 */
public class FontReader {
	
	private static Font menuFont = null;
	private static Font menuItemFont = null;
	private static Font stateBarFont = null;
	private static Font tabTitleFont = null;
	
	/**
	 * ڸ ϸ ü  ϱ ϱ  Private ü.
	 */
	private FontReader() {}
	
	/**
	 * Menu ϴ Ʈ  ȯ.
	 * @return Menu ϴ Ʈ.
	 */
	public static Font getMenuFont(MainFrame mainFrame){
		if(menuFont == null){
			String fontPropertiesFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "fontFile");
			String fontFileName = new PropertiesReader(mainFrame).getPropertyValue(fontPropertiesFileName, "menuBarFontFileName");
			String fontSize = new PropertiesReader(mainFrame).getPropertyValue(fontPropertiesFileName, "menuBarFontSize");

			try {
				menuFont = Font.createFont(Font.TRUETYPE_FONT, new FileInputStream(new File(fontFileName)));
				menuFont = menuFont.deriveFont(Font.PLAIN, Float.parseFloat(fontSize));
			} catch (Exception e){
				LoggerReader.getLogger(mainFrame).warn("޴ Ʈ б  (" + e.getMessage() + ")");
			}
//			menuFont = new Font("Default", Font.PLAIN, 12);
		}
		return menuFont;
	}
	
	/**
	 * MenuItem ϴ Ʈ  ȯ.
	 * @return MenuItem ϴ Ʈ.
	 */
	public static Font getMenuItemFont(MainFrame mainFrame){
		if(menuItemFont == null){
			String fontPropertiesFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "fontFile");
			String fontFileName = new PropertiesReader(mainFrame).getPropertyValue(fontPropertiesFileName, "menuItemFontFileName");
			String fontSize = new PropertiesReader(mainFrame).getPropertyValue(fontPropertiesFileName, "menuItemFontSize");

			try {
				menuItemFont = Font.createFont(Font.TRUETYPE_FONT, new FileInputStream(new File(fontFileName)));
				menuItemFont = menuItemFont.deriveFont(Font.PLAIN, Float.parseFloat(fontSize));
			} catch (Exception e){
				LoggerReader.getLogger(mainFrame).warn("޴  Ʈ б  (" + e.getMessage() + ")");
			}
//			menuItemFont = new Font("Default", Font.PLAIN, 12);
		}
		return menuItemFont;
	}
	
	/**
	 * StateBar ϴ Ʈ  ȯ.
	 * @return StateBar ϴ Ʈ.
	 */
	public static Font getStateBarFont(MainFrame mainFrame){
		if(stateBarFont == null){
			String fontPropertiesFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "fontFile");
			String fontFileName = new PropertiesReader(mainFrame).getPropertyValue(fontPropertiesFileName, "stateBarFontFileName");
			String fontSize = new PropertiesReader(mainFrame).getPropertyValue(fontPropertiesFileName, "stateBarFontSize");
			
			try {
				stateBarFont = Font.createFont(Font.TRUETYPE_FONT, new FileInputStream(new File(fontFileName)));
				stateBarFont = stateBarFont.deriveFont(Font.PLAIN, Float.parseFloat(fontSize));
			} catch (Exception e){
				LoggerReader.getLogger(mainFrame).warn("¹ Ʈ б  (" + e.getMessage() + ")");
			}
//			stateBarFont = new Font("Default", Font.PLAIN, 11);
		}
		return stateBarFont;
	}
	
	/**
	 * TabTitle ̸ Ǵ Ʈ  ȯ.
	 * @return TabTitle ϴ Ʈ.
	 */
	public static Font getTabTitleFont(MainFrame mainFrame){
		if(tabTitleFont == null){
			String fontPropertiesFileName = new PropertiesReader(mainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "fontFile");
			String fontFileName = new PropertiesReader(mainFrame).getPropertyValue(fontPropertiesFileName, "tabTitleFontFileName");
			String fontSize = new PropertiesReader(mainFrame).getPropertyValue(fontPropertiesFileName, "tabTitleBarFontSize");
			
			try {
				tabTitleFont = Font.createFont(Font.TRUETYPE_FONT, new FileInputStream(new File(fontFileName)));
				tabTitleFont = tabTitleFont.deriveFont(Font.PLAIN, Float.parseFloat(fontSize));
			} catch (Exception e){
				LoggerReader.getLogger(mainFrame).warn("TabTitle Ʈ б  (" + e.getMessage() + ")");
			}
//			stateBarFont = new Font("Default", Font.PLAIN, 11);
		}
		return tabTitleFont;
	}
}
