/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ****************************
 *                             
 * [¥]         [۾]             []
 * 2007. 08. 28   Ҳڹ          Ŭ ó ۼ  
 * 
 ********************************************************************
 */

package com.nate.hjy7942.database;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

/**
 * ۼ : 2007. 08. 28
 * ۼ : Ҳڹ 
 * <br>
 * DbConnectionProperties  ͺ̽ Ŀؼ ϴ Ŭ
 */
public class DatabaseConnectionHandler {
	
	private DatabaseConnectionProperties dbProperties;
	private boolean changed = false;
	private Connection connection;
	
	private final Object finalizerGuardian = new Object() {
		protected void finalize() {
			try {
				closeConnection();
			} catch (IllegalConnectionException e) {
				//TODO α׿  
				e.printStackTrace();
			}
		}
	};
	
	public DatabaseConnectionHandler(DatabaseConnectionProperties dbProperties) {
		this.dbProperties = dbProperties;
	}
	
	public DatabaseConnectionHandler() {
		this.dbProperties = new DatabaseConnectionProperties();
	}
	
	private void loadConnection() throws IllegalConnectionException {
		try {
			Class.forName("oracle.jdbc.OracleDriver");
			connection = DriverManager.getConnection( dbProperties.getUrl(), dbProperties.getProperties("user"),
					dbProperties.getProperties("password") );

		} catch (ClassNotFoundException e) {
			// TODO log   
			throw new IllegalConnectionException(e);
		} catch (SQLException e) {
			// TODO log   
			throw new IllegalConnectionException(e);
		}
	}
	
	public Connection getConnection() throws IllegalConnectionException {
		if(connection == null) {
			loadConnection();
		}
		return connection;
	}
	
	public void reLoad() throws IllegalConnectionException  {
		loadConnection();
	}
	
	public void closeConnection() throws IllegalConnectionException {
		try {
			if(connection != null)
				connection.close();

		} catch (SQLException e) {
			//TODO log   
			throw new IllegalConnectionException(e);			
		} 
		try {
			if(dbProperties != null) {
				dbProperties.saveProperties();
			}
		} catch (IOException e) {
			//TODO log   
			throw new IllegalConnectionException(e);			
		}
	
	}
	
	
	/**
	 * Connection Name Ű Ѵ.
	 * @return
	 */
	public String getKey() {
		return dbProperties.getKey();
	}
	
	
	
	public String toString() {
		return dbProperties.toString();
	}
	
	public String getUser() {
		return dbProperties.getProperties(DatabaseConnectionProperties.USER);
	}

	public String getPassword() {
		return dbProperties.getProperties(DatabaseConnectionProperties.PASSWORD);
	}

	public String getServiceName() {
		return dbProperties.getProperties(DatabaseConnectionProperties.SERVICE_NAME);
	}

	public String getPortNumber() {
		return dbProperties.getProperties(DatabaseConnectionProperties.PORT_NUMBER);
	}

	public String getHostName() {
		return dbProperties.getProperties(DatabaseConnectionProperties.HOST_NAME);
	}
	
	public String getDriver() {
		return dbProperties.getProperties(DatabaseConnectionProperties.DRIVER);
	}
	
	public void setConnectionName(String connectionName) {
		dbProperties.setConnectionName(connectionName);
	}
	
	public void setUserName(String userName) {
		dbProperties.setUserName(userName);
	}
	
	public void setPassword(String password) {
		dbProperties.setPassword(password);
	}
	
	public void setServiceName(String serviceName) {
		dbProperties.setServiceName(serviceName);
	}
	
	public void setPortNumber(String portNumber) {
		dbProperties.setPortNumber(portNumber);
	}
	
	public void setHostName(String hostName) {
		dbProperties.setHostName(hostName);
	}
	
	public void setDriver(String driver) {
		dbProperties.setDriver(driver);
	}
	
	
	
}
