/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ****************************
 *                             
 * [¥]         [۾]             []
 * 2007. 08. 28   Ҳڹ          Ŭ ó ۼ  
 * 
 ********************************************************************
 */

package com.nate.hjy7942.database;

import java.io.File;
import java.sql.Connection;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.Vector;

import com.nate.hjy7942.ui.DatabaseConnectionView;

/** 
 * ۼ : 2007. 08. 28
 * ۼ : Ҳڹ 
 * <br>
 * ͺ̽ Ŀؼ ϴ Ŭ<br>
 * DbConnectionHandler Ѵ. 
 */
public class DatabaseConnectionManager {
	
	private static Map connectionMap;
	private static DatabaseConnectionManager instance;

	private final Object finalizerGuardian = new Object() {
		protected void finalize() {
			try {
				close();
			} catch (IllegalConnectionException e) {
				// TODO α   
				e.printStackTrace();
			}
		}
	};
	
	private Vector<DatabaseConnectionView> connectionViews;

	
	private DatabaseConnectionManager() {
		connectionViews = new Vector<DatabaseConnectionView>();
	}
	
	
	private static synchronized void initMapIfNecessary() {
		if(instance == null) {
			connectionMap = new HashMap();
			loadAll();
			instance = new DatabaseConnectionManager();
		}
		
	}
	
	public void addView(DatabaseConnectionView view) {
		connectionViews.add(view);
	}
	
	public static DatabaseConnectionManager getInstance() {
		initMapIfNecessary();
		return instance;
	}
	
	private static void putDbConnectionHandler(DatabaseConnectionHandler element) {
		if(element == null) {
			throw new IllegalArgumentException("Argument is invalid!");
		}
		connectionMap.put(element.getKey(), element);
	}
	
	public void put(DatabaseConnectionHandler element) {
		putDbConnectionHandler(element);
		
		for(Iterator each = connectionViews.iterator(); each.hasNext(); ) {
			DatabaseConnectionView view = (DatabaseConnectionView) each.next();
			view.addConnectionHandler(element);
		}
	}

	public Connection get(String key) throws IllegalConnectionException {
		if(key == null) {
			throw new IllegalArgumentException("Argument is invalid!");
		}
		return ((DatabaseConnectionHandler) connectionMap.get(key)).getConnection();
	}
	
	public DatabaseConnectionHandler getConnectionHandler(String key) {
		if(key == null) {
			throw new IllegalArgumentException("Argument is invalid!");
		}
		return (DatabaseConnectionHandler) connectionMap.get(key);
		
	}
	public boolean containsKey(String key) {
		return connectionMap.containsKey(key);
	}
	
	private static void loadAll() {
		File files = new File(DatabaseConnectionProperties.PATH);
		File[] propertyFileList = files.listFiles();
		for(int i=0; i<propertyFileList.length; i++) {
			if(!propertyFileList[i].isDirectory()) {
				String filePath = propertyFileList[i].toString();
				String[] tempSplites = filePath.split("\\" + File.separator);
				int indexOf = tempSplites[tempSplites.length-1].indexOf('.');
				String propertyName = tempSplites[tempSplites.length-1].substring(0, indexOf);
				String fileExtender = tempSplites[tempSplites.length-1].substring(indexOf +1);
				if( fileExtender.equals(DatabaseConnectionProperties.FILE_EXTENDER) ) {
					DatabaseConnectionProperties dbProperties = new DatabaseConnectionProperties(propertyName);
					putDbConnectionHandler(new DatabaseConnectionHandler(dbProperties));
				}
			}
		}
	}
	
	public void close() throws IllegalConnectionException {
		Collection connectiones = connectionMap.values();
		for(Iterator iter = connectiones.iterator(); iter.hasNext(); ){
			DatabaseConnectionHandler each = (DatabaseConnectionHandler) iter.next();
			each.closeConnection();
		}
		
	}
	
	public String toString() {
		return connectionMap.toString();
	}
	
	public void reLoadAll() {
		loadAll();
	}
	
	public void reload(String key) throws IllegalConnectionException {
		if(key == null) {
			throw new IllegalArgumentException("Argument is invalid!");
		}
		DatabaseConnectionHandler dbConnectionHandler = (DatabaseConnectionHandler) connectionMap.get(key);
		dbConnectionHandler.reLoad();
		
	}
	
	public Set keySet() {
		return connectionMap.keySet();
	}
	

	
		
}
