/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ****************************
 *                             
 * [¥]         [۾]             []
 * 2007. 08. 27   Ҳڹ          Ŭ ó ۼ  
 * 
 ********************************************************************
 */

package com.nate.hjy7942.database;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Properties;

/**
 * 
   * ۼ : 2007. 08. 27
   * ۼ : Ҳڹ 
   * <br>
   * ͺ̽  ϴ Ŭ
 */
public class DatabaseConnectionProperties {
	
	private Properties properties;
	
	public static final String NAME = "name";
	public static final String USER = "user";
	public static final String PASSWORD = "password";
	public static final String SERVICE_NAME = "serviceName";
	public static final String PORT_NUMBER = "portNumber";
	public static final String HOST_NAME = "hostName";
	public static final String DRIVER = "driver";
	
	
	private final String[] propertyNames = { NAME, USER, PASSWORD,
											SERVICE_NAME, PORT_NUMBER, HOST_NAME, 
											DRIVER };
	
 
	static final String PATH = "conf" + File.separator + "database" + File.separator;
	static final String FILE_EXTENDER = "properties";
	
	void setConnectionName(String connectionName) {
		key = connectionName;
		setPropertie(NAME, connectionName);
	}
	
	void setUserName(String userName) {
		setPropertie(USER, userName);
	}
	
	void setPassword(String password) {
		setPropertie(PASSWORD, password);
	}
	
	void setServiceName(String serviceName) {
		setPropertie(SERVICE_NAME, serviceName);
	}
	
	void setPortNumber(String portNumber) {
		setPropertie(PORT_NUMBER, portNumber);
	}
	
	void setHostName(String hostName) {
		setPropertie(HOST_NAME, hostName);
	}
	
	void setDriver(String driver) {
		setPropertie(DRIVER, driver);
	}
	
	/**
	 * Ŀؼ ϴ 
	 */
	private String key;
	
	private final Object finalizerGuardian = new Object() {
		protected void finalize() throws Throwable {
			saveProperties();
		}
	};
	
	public DatabaseConnectionProperties() { properties = new Properties(); }
	
	DatabaseConnectionProperties(String connectionName) {
		try {
			key = connectionName;
			loadProperties(connectionName);
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
	
	private void loadProperties(String name) throws IOException {
		FileInputStream fis = new FileInputStream(PATH + key + "." + FILE_EXTENDER);
		Properties tempProperties = new Properties();
		tempProperties.load(fis);
		if( isValidProperties(tempProperties) ) {
			properties = tempProperties;
		}
		
		fis.close();
	}
	
	/**
	 * @param tempProperties
	 * @return
	 */
	private boolean isValidProperties(Properties tempProperties) {
		for(Enumeration propertyNames=tempProperties.propertyNames(); propertyNames.hasMoreElements();) {
			String key = (String) propertyNames.nextElement();
			if(!isContainedKey(key)) return false;  
		}
	
		return true;
	}
	void saveProperties() throws IOException {
		FileOutputStream fos = new FileOutputStream(PATH + getProperties("name") + "." + FILE_EXTENDER);
		properties.store(fos, "comments");
		fos.close();
	}
	
	
	public void setPropertie(String key, String value) {
/*		if(isContainedKey(key)) {
			properties.setProperty(key, value);
		}
*/		
		if(key != null) {
			properties.setProperty(key, value);
		} else {
			throw new IllegalArgumentException("Key is invaild!");
		}
	}
	
	public String getProperties(String key) {
		if(isContainedKey(key)) {
			return properties.getProperty(key);
		}
		else {
			throw new IllegalArgumentException("Key is invaild!");
		}
	}
	
	private boolean isContainedKey(String key ){
		for(int i=0; i<propertyNames.length; i++) {
			if(key.equals(propertyNames[i]))
				return true;
		}
		return false;
	}
	
	public String getKey() {
		return key;
	}
	
	
	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((key == null) ? 0 : key.hashCode());
		result = prime * result
				+ ((properties == null) ? 0 : properties.hashCode());
		return result;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!(obj instanceof DatabaseConnectionProperties))
			return false;
		final DatabaseConnectionProperties other = (DatabaseConnectionProperties) obj;
		if (key == null) {
			if (other.key != null)
				return false;
		} else if (!key.equals(other.key))
			return false;
		if (properties == null) {
			if (other.properties != null)
				return false;
		} else if (!properties.equals(other.properties))
			return false;
		return true;
	}
	
	public String toString() {
/*		return "key=" + key 
			+ "\n" + properties.toString();
*/
		return getUrl();
	}
	
	String getUrl() {
		return getProperties("user") 
				+ "@" + getProperties("driver") 
				+ ":" + "@" + getProperties("hostName") 
				+ ":" + getProperties("portNumber")
				+ ":" + getProperties("serviceName");
	}
	

	
}
