/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Sep 7, 2007   Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.dialog;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.database.DatabaseConnectionHandler;
import com.nate.hjy7942.database.DatabaseConnectionManager;
import com.nate.hjy7942.util.SystemProperties;

/**
 * ۼ : Sep 7, 2007
 * ۼ : Ҳڹ 
 * <br>
 *  ־ ּ!!
 */
public class DatabaseConnectionDialog extends JDialog{
	
	private MainFrame mainFrame;
	private JPanel mainPanel;
	private JPanel centerPanel;
	private JPanel northPanel;
	private JPanel westPanel;
	private JPanel center_centerPanel;
	private JPanel center_center_northPanel;
	private JPanel center_northPanel;
	private JPanel center_center_centerPanel;
	private JPanel center_southPanel;
	
	private JTextField tf_connectionName;
	private JTextField tf_userName;
	private JPasswordField pf_password;
	
	private JTextField tf_hostName;
	private JTextField tf_port;
	
	private JTextField tf_sid;
	private JTextField tf_serviceName;
	
	private JTextField[] textFieldes; 
	
	private JButton button_save;
	private JButton button_clear;
	private JButton button_test;
	private JButton button_connect;
	private JButton button_cancel;
	
	private JRadioButton rb_sid;
	private JRadioButton rb_serviceName;
	private ButtonGroup radioGroup;
	
	
	private JTable table_connectiones;
	private JScrollPane jsp_connectiones;
	private JButton button_help;
	private GridBagConstraints gridConstraints;
	
	private final String SID = "SID";
	private final String SERVICE_NAME = "Service name";
	private Point centerPosition;
	
	private DatabaseConnectionManager dbConnectionManager;
	
	public DatabaseConnectionDialog(MainFrame mainFrame, DatabaseConnectionManager dbConnectionManager) {
		super(mainFrame, true);
		this.mainFrame = mainFrame;
		this.dbConnectionManager = dbConnectionManager;
		initialize();
	}
	
	/*
	 * ׽Ʈ 
	 */
	public DatabaseConnectionDialog(JFrame mainFrame, DatabaseConnectionManager dbConnectionManager) {
		super(mainFrame, true);
		this.dbConnectionManager = dbConnectionManager;
		initialize();
	}


	/**
	 * 
	 */
	private void initlizeScreeInformation() {
		centerPosition = SystemProperties.getCenterPoint(this);
	}
	
	private void initializeTable() {
		DatabaseConnectionTable connectionTable = new DatabaseConnectionTable(dbConnectionManager, this);
		table_connectiones = connectionTable.getTable();
		jsp_connectiones = new JScrollPane(table_connectiones);

		
					
	}
	
	private void initializeComponent() {
		initializeGridConstraints();
		initializeTextFieldes();
		initializeButtons();
		initializeRadioButtons();
		initializeTable();
	}

	private void initializeRadioButtons() {
		
		rb_sid = new JRadioButton(SID);
		rb_sid.setActionCommand(SID);
		rb_sid.addActionListener(new RadioActionListener());
		
		rb_serviceName = new JRadioButton(SERVICE_NAME);
		rb_serviceName.setActionCommand(SERVICE_NAME);
		rb_serviceName.addActionListener(new RadioActionListener());
		
		radioGroup = new ButtonGroup();
		radioGroup.add(rb_sid);
		radioGroup.add(rb_serviceName);
		
		rb_sid.setSelected(true);
		disableTextField(tf_serviceName);
	}

	/**
	 * 
	 */
	private void initializeButtons() {
		button_save = new JButton("Save");
		button_save.addActionListener(new SaveButtonActionListener());
		button_clear = new JButton("Clear");
		button_clear.addActionListener(new ClearButtonActionListener());
		button_test = new JButton("Test");
		button_connect = new JButton("Connect");
		button_cancel = new JButton("");
		button_cancel.addActionListener(new CancelButtonActionListener());
		button_help = new JButton("");
	}

	/**
	 * 
	 */
	private void initializeTextFieldes() {
		int size = 30;
		tf_connectionName = new JTextField(size);
		tf_userName = new JTextField(size);
		pf_password = new JPasswordField(size);		

		tf_hostName = new JTextField(size);
		tf_port = new JTextField(size);
		tf_port.setDocument(new IntegerDocument());
		tf_sid = new JTextField(size);
		tf_serviceName = new JTextField(size);
		
		JTextField[] tempTextFieldes = { tf_connectionName, tf_userName, pf_password, 
			 tf_hostName, tf_port };
		textFieldes = tempTextFieldes;
	

	}
	
	

	/**
	 * 
	 */
	private void initialize() {
		setTitle("New / Select Database Connection");
		initializeComponent();
		buildMainPanel();
		pack();
		initlizeScreeInformation();
		this.setResizable(false);
	}
	
	private void buildMainPanel() {
		buildWestPanel();
		buildCenterPanel();
		mainPanel = new JPanel(new BorderLayout());
		mainPanel.add("West", westPanel);
		mainPanel.add("Center", centerPanel);
		this.setContentPane(mainPanel);
	}
	
	private void buildWestPanel() {
		westPanel = new JPanel(new BorderLayout());
		JPanel centerPanel = new JPanel();
		centerPanel.add(jsp_connectiones);
		JPanel southPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
		southPanel.add(button_help);
		westPanel.add("Center", centerPanel);
		westPanel.add("South", southPanel );
	}
	
	private void buildCenterPanel() {
		buildCenter_northPanel();
		buildCenter_southPanel();
		centerPanel = new JPanel(new BorderLayout());
		center_centerPanel = new JPanel(new BorderLayout());
		
		center_center_northPanel = new JPanel();
		buildCenter_center_southPanel();
		
		center_centerPanel.add("North", center_center_northPanel);
		center_centerPanel.add("South", center_center_centerPanel);
		
		centerPanel.add("North", center_northPanel);
		centerPanel.add("Center", center_centerPanel);
		centerPanel.add("South", center_southPanel);
	}

	/**
	 * 
	 */
	private void buildCenter_southPanel() {
		center_southPanel = new JPanel();
		center_southPanel.add(button_save);
		center_southPanel.add(button_clear);
		center_southPanel.add(button_test);
		center_southPanel.add(button_connect);
		center_southPanel.add(button_cancel);
	}

	/**
	 * 
	 */
	private void buildCenter_center_southPanel() {
		center_center_centerPanel = new JPanel(new GridBagLayout());
		JLabel l_hostName = new JLabel("Hostname : ");
		
		setGridConstraints(0,0,new Insets(10,10,10,0));
		center_center_centerPanel.add(l_hostName, gridConstraints);
		
		setGridConstraints(1,0,new Insets(10,0,10,10));
		center_center_centerPanel.add(tf_hostName, gridConstraints);

		JLabel l_port = new JLabel("Port : ");
		setGridConstraints(0,1,new Insets(10,10,10,0));
		center_center_centerPanel.add(l_port, gridConstraints);

		setGridConstraints(1,1,new Insets(10,0,10,10));
		center_center_centerPanel.add(tf_port, gridConstraints);
		
		setGridConstraints(0,2,new Insets(10,10,10,0));	
		center_center_centerPanel.add(rb_sid, gridConstraints);
		
		setGridConstraints(1,2,new Insets(10,0,10,10));
		center_center_centerPanel.add(tf_sid, gridConstraints);

		setGridConstraints(0,3,new Insets(10,10,10,5));
		center_center_centerPanel.add(rb_serviceName, gridConstraints);

		setGridConstraints(1,3,new Insets(10,0,10,10));
		gridConstraints.insets = new Insets(10,0,10,10);
		center_center_centerPanel.add(tf_serviceName, gridConstraints);
	}
	
	private void setGridConstraints(int gridx, int gridy, Insets insets) {
		gridConstraints.insets = insets;
		gridConstraints.gridx = gridx;
		gridConstraints.gridy = gridy;
	}

	/**
	 * 
	 */
	private void buildCenter_northPanel() {
		center_northPanel = new JPanel(new GridBagLayout());
		JLabel l_connectionName = new JLabel("Connection Name : ", JLabel.LEFT);

		setGridConstraints(0,0,new Insets(10,10,10,5));
		center_northPanel.add(l_connectionName, gridConstraints);

		setGridConstraints(1,0,new Insets(10,0,10,10));
		center_northPanel.add(tf_connectionName, gridConstraints);

		
		JLabel l_userName = new JLabel("User Name : ", JLabel.LEFT);
		setGridConstraints(0,1,new Insets(10,10,10,5));
		center_northPanel.add(l_userName, gridConstraints);
		
		setGridConstraints(1,1,new Insets(10,0,10,10));
		center_northPanel.add(tf_userName, gridConstraints);

		JLabel l_password = new JLabel("Password Name : ", JLabel.LEFT);
		setGridConstraints(0,2,new Insets(10,10,10,5));
		center_northPanel.add(l_password, gridConstraints);

		setGridConstraints(1,2,new Insets(10,0,10,10));
		center_northPanel.add(pf_password, gridConstraints);
	}

	private void clearTextFieldes() {
		tf_connectionName.setText("");
		tf_userName.setText("");
		pf_password.setText("");		
		
		tf_hostName.setText("");
		tf_port.setText("");
		tf_sid.setText("");
		tf_serviceName.setText("");
	}

	private void initializeGridConstraints() {
		gridConstraints = new GridBagConstraints();
		gridConstraints.fill = GridBagConstraints.HORIZONTAL;
		gridConstraints.weightx = 0.1;
	}
	
	public JPanel getMainPanel() {
		return mainPanel;
	}
	
	private void setPosition() {
		this.setLocation(centerPosition);
	}
	
	public void setUserName(String userName) {
		tf_userName.setText(userName);
	}
	
	public void setConnectionName(String connectionName) {
		tf_connectionName.setText(connectionName);
	}
	
	public void setPassword(String password) {
		pf_password.setText(password);
	}
	
	public void setHostName(String hostName) {
		tf_hostName.setText(hostName);
	}
	
	public void setSid(String sid) {
		if(rb_sid.isSelected())
			tf_sid.setText(sid);
		else 
			tf_serviceName.setText(sid);
	}
	
	public void seterviceName(String serviceName) {
		tf_serviceName.setText(serviceName);
	}
	
	public void setPort(int port) {
		tf_port.setText(String.valueOf(port));
	}
	
	
	public void setVisible(boolean b) {
		this.setPosition();
		super.setVisible(b);
	}
	
	private class CancelButtonActionListener implements ActionListener {

		public void actionPerformed(ActionEvent e) {
			clearTextFieldes();
			DatabaseConnectionDialog.this.setVisible(false);
		}
		
	}
	
	private class ClearButtonActionListener implements ActionListener {

		public void actionPerformed(ActionEvent e) {
			clearTextFieldes();
			
		}
	}
	
	/**
	 * 
	 * @return  ִ ؽƮʵ 迭  ,  -1 Ѵ.
	 */
	private int checkEmptyTextFied() {
		for(int i=0; i<textFieldes.length; i++) {
			String text = textFieldes[i].getText();
			if(text == null || text.trim().length() == 0)
				return i;
		}
		return -1;
	}
	
	private boolean isFullSid() {
		return (tf_sid.getText().trim().length() != 0) ? true : false;
	}
	
	private boolean isFullServiceName() {
		return (tf_serviceName.getText().trim().length() != 0) ? true : false;
	}

	private class SaveButtonActionListener implements ActionListener {

		public void actionPerformed(ActionEvent e) {
			int emptyTextfieldIndex = checkEmptyTextFied();
			if(emptyTextfieldIndex != -1) {
				textFieldes[emptyTextfieldIndex].requestFocus();
				return;
			}
			if( !(isFullSid() || isFullServiceName()) ) {
				return;
			}
			
			String connectionName = tf_connectionName.getText().trim();
			if(dbConnectionManager.containsKey(connectionName)) {
				// TODO Ʈ Ÿ JLabel   Ŀؼ ̸ ߺǾٴ  ǥѴ.
				tf_connectionName.requestFocus();
				return;
			}
			
			DatabaseConnectionHandler connectionHandler = new DatabaseConnectionHandler();
			connectionHandler.setConnectionName(tf_connectionName.getText());
			connectionHandler.setUserName(tf_userName.getText());
			connectionHandler.setPassword(String.valueOf(pf_password.getPassword()));
			connectionHandler.setPortNumber(tf_port.getText());
			connectionHandler.setHostName(tf_hostName.getText());
			connectionHandler.setServiceName(tf_serviceName.getText());
			connectionHandler.setDriver("jdbc:oracle:thin");
			dbConnectionManager.put(connectionHandler);
			System.out.println(connectionHandler);
		}
		
	}
	
	
	
	private void enableTextField(JTextField textField) {
		textField.setEnabled(true);
		textField.setBackground(Color.WHITE);
	}
	
	private void disableTextField(JTextField textField) {
		textField.setEnabled(false);
		textField.setBackground(Color.LIGHT_GRAY);
		textField.setText("");
	}
	
	private class RadioActionListener implements ActionListener {

		public void actionPerformed(ActionEvent e) {
			String command = e.getActionCommand();
			if(command.equals(SID)) {
				disableTextField(tf_serviceName);
				enableTextField(tf_sid);
			} else if(command.equals(SERVICE_NAME)) {
				disableTextField(tf_sid);
				enableTextField(tf_serviceName);
			}
		}
	}
	
	static class IntegerDocument extends PlainDocument {

		public void insertString(int offset, String string, AttributeSet attributes)
			throws BadLocationException {

			if (string == null) {
				return;
			} else {
				String newValue;
				int length = getLength();
				if (length == 0) {
					newValue = string;
				} else {
					String currentContent = getText(0, length);
					StringBuffer currentBuffer =
					new StringBuffer(currentContent);
					currentBuffer.insert(offset, string);
					newValue = currentBuffer.toString();
				}
				try {
					Integer.parseInt(newValue);
					super.insertString(offset, string, attributes);
				} catch (NumberFormatException exception) {
					Toolkit.getDefaultToolkit().beep();
				}
			}
		}
	}
	
	
	
	public static void main(String[] args) {
		JFrame frame = new JFrame("test");
		DatabaseConnectionDialog dialog = new DatabaseConnectionDialog(frame, DatabaseConnectionManager.getInstance());
		dialog.setVisible(true);
	}
	
	
	
	
	
	
}