/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ****************************
 *                             
 * [¥]         [۾]             []
 * 2007. 09. 16   Ҳڹ()          Ŭ ó ۼ  
 * 
 ********************************************************************
 */

package com.nate.hjy7942.ui.dialog;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Iterator;
import java.util.Set;
import java.util.Vector;

import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableModel;

import com.nate.hjy7942.database.DatabaseConnectionHandler;
import com.nate.hjy7942.database.DatabaseConnectionManager;
import com.nate.hjy7942.ui.DatabaseConnectionView;

/**
 * ۼ : 2007. 09. 16
 * ۼ : Ҳڹ() 
 * <br>
 *  ־ ּ!!
 */
class DatabaseConnectionTable implements DatabaseConnectionView {
	private JTable connectionTable;
	private DatabaseConnectionManager connectionManager;
	private DefaultTableModel tableModel;
	private DatabaseConnectionDialog connectionDialog;
	
	
	DatabaseConnectionTable(DatabaseConnectionManager connectionManager, DatabaseConnectionDialog connectionDialog) {
		this.connectionManager = connectionManager;
		connectionManager.addView(this);
		this.connectionDialog = connectionDialog;
		initialize();
	}

	/**
	 * 
	 */
	private void initialize() {
		initializeData();
		connectionTable.addMouseListener(new TableMouseListener());
	}

	/**
	 * 
	 */
	private void initializeData() {
		Vector columnNames = initializeColumn();


/*		String[][] testValue = 
		{
				{"DevelopDB", "sys@//localhost:1521"},
				{"TestDB", "scott@//localhost:1521"}
		};
*/
		Vector rows = new Vector();
		Set keys = connectionManager.keySet();
		for(Iterator key = keys.iterator(); key.hasNext(); ) {
			String connectionName = (String) key.next();
			Vector record = new Vector();
			record.add(connectionName);
			record.add(connectionManager.getConnectionHandler(connectionName));
			rows.add(record);
		}
		
		tableModel = new DefaultTableModel(rows, columnNames) {
			@Override
			public boolean isCellEditable(int row, int column) {
				return false;
			}
			
		};
		connectionTable = new JTable(tableModel);
		connectionTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	}

	/**
	 * @return
	 */
	private Vector initializeColumn() {
		Vector columnNames = new Vector(); 
		columnNames.add("Connection Name");
		columnNames.add("Connection Details");
		return columnNames;
	}
	
	public JTable getTable() {
		return connectionTable;
	}
	
	private class TableMouseListener extends MouseAdapter {

		@Override
		public void mouseClicked(MouseEvent e) {
			int selectedRow = connectionTable.getSelectedRow();
			DatabaseConnectionHandler connectionHandler = (DatabaseConnectionHandler) tableModel.getValueAt(selectedRow, 1);
			writeConnectionInformationToTextField(connectionHandler);
		}

		/**
		 * @param connectionHandler
		 */
		private void writeConnectionInformationToTextField(
				DatabaseConnectionHandler connectionHandler) {
			connectionDialog.setConnectionName(connectionHandler.getKey());
			connectionDialog.setUserName(connectionHandler.getUser());
			connectionDialog.setPassword(connectionHandler.getPassword());
			connectionDialog.setPort(Integer.parseInt(connectionHandler.getPortNumber()));
			connectionDialog.setHostName(connectionHandler.getHostName());
			connectionDialog.setSid(connectionHandler.getServiceName());
		}
		
	}

	/* (non-Javadoc)
	 * @see com.nate.hjy7942.ui.DatabaseConnectionView#updateUI()
	 */
//	@Override
	public void updateUI() {
		initializeData();
	}
	
	public void addConnectionHandler(DatabaseConnectionHandler handler) {
		Vector row = new Vector();
		row.add(handler.getKey());
		row.add(handler);
		tableModel.addRow(row);
		connectionTable.updateUI();
	}
	
}
