/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Sep 16, 2007   Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.dialog;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.EventHandler;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import net.infonode.tabbedpanel.titledtab.TitledTab;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.ui.tabmodule.workviewer.TextPaneComponent;
import com.nate.hjy7942.util.SystemProperties;

/**
 * ۼ : Sep 16, 2007
 * ۼ : Ҳڹ 
 * <br>
 *  ־ ּ!!
 */
public class FindReplaceDialog extends JDialog{
	
	private MainFrame mainFrame = null;
	private TextPaneComponent textPane = null;
	private static FindReplaceDialog fileReplace = null;
	
	private JTextField fineText;
	private JTextField replaceText;
	private int currentCaret;
	private int textLength;
	private int start;
	
	private FindReplaceDialog(Container parentDialog) {
		super((JFrame) parentDialog, false);
		this.mainFrame = (MainFrame) parentDialog;
		dialogInitialize();
	}

	private void dialogInitialize() {
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				fileReplace.dispose();
				fileReplace = null;
			}
		});
		setSize(270, 160);
		setLocation(SystemProperties.getCenterPoint(this));
		setTitle("Find/Replace");
		setResizable(false);
		getContentPane().setLayout(null);

		final JLabel findLabel_1 = new JLabel();
		findLabel_1.setText("Find :");
		findLabel_1.setBounds(10, 10, 90, 18);
		getContentPane().add(findLabel_1);

		final JLabel findLabel = new JLabel();
		findLabel.setText("Replace With :");
		findLabel.setBounds(10, 34, 90, 18);
		getContentPane().add(findLabel);

		replaceText = new JTextField();
		replaceText.setBounds(110, 34, 140, 18);
		getContentPane().add(replaceText);

		fineText = new JTextField();
		fineText.setBounds(110, 10, 140, 18);
		getContentPane().add(fineText);

		final JButton findNextButton = new JButton();
		findNextButton.addActionListener((ActionListener) EventHandler.create(ActionListener.class, this, "clickFindNextButton"));
		findNextButton.setText("Find Next");
		findNextButton.setBounds(10, 71, 110, 21);
		getContentPane().add(findNextButton);

		final JButton findProviousButton = new JButton();
		findProviousButton.addActionListener((ActionListener) EventHandler.create(ActionListener.class, this, "clickFindPreviousButton"));
		findProviousButton.setText("Find Previous");
		findProviousButton.setBounds(144, 71, 110, 21);
		getContentPane().add(findProviousButton);

		final JButton replaceButton = new JButton();
		replaceButton.addActionListener((ActionListener) EventHandler.create(ActionListener.class, this, "clickReplaceButton"));
		replaceButton.setText("Replace");
		replaceButton.setBounds(10, 98, 110, 21);
		getContentPane().add(replaceButton);

		final JButton replaceAllButton = new JButton();
		replaceAllButton.addActionListener((ActionListener) EventHandler.create(ActionListener.class, this, "clickReplaceAllButton"));
		replaceAllButton.setText("Replace All");
		replaceAllButton.setBounds(144, 98, 110, 21);
		getContentPane().add(replaceAllButton);
	}
	
	public static void showDialog(Container parentDialog){
		if(fileReplace != null) {
			return;
		}
		TitledTab titleTab = (TitledTab) ((MainFrame) parentDialog).getTabbedCenterCenter().getSelectedTab();
		if(titleTab == null) {
			return;
		}
		
		System.out.println(titleTab);
		fileReplace = new FindReplaceDialog(parentDialog);
		fileReplace.setVisible(true);
	}
	
	public static FindReplaceDialog getDialog(){
		if(fileReplace == null){
			return null;
		}
		return fileReplace;
	}
	
	public void clickFindNextButton(){
		if(findText()) {
			getTextPane().select(start, start + textLength);
		}
	}
	
	public void clickFindPreviousButton(){
		//TODO  ã  ؾ.
	}
	
	public void clickReplaceButton(){
		StringBuffer sb = new StringBuffer(getTextPane().getText());
		sb.replace(start, start + textLength, replaceText.getText());
		getTextPane().setText(sb.toString());
		getTextPane().setCaretPosition(currentCaret);
	}
	
	public void clickReplaceAllButton(){
		while(findText()){
			StringBuffer sb = new StringBuffer(getTextPane().getText());
			sb.replace(start, start + textLength, replaceText.getText());
			getTextPane().setText(sb.toString());
			getTextPane().setCaretPosition(currentCaret);
		}
}
	
	private boolean findText(){
		this.currentCaret = this.getTextPane().getCaretPosition();
		textLength = fineText.getText().length();
		start = getTextPane().getText().indexOf(fineText.getText(), currentCaret);
		if(start == -1) {
			return false;
		}
		return true;
	}
	
	private TextPaneComponent getTextPane(){
		TitledTab titleTab = (TitledTab) mainFrame.getTabbedCenterCenter().getSelectedTab();
		JScrollPane scrollPane = (JScrollPane) titleTab.getContentComponent();
		textPane = (TextPaneComponent) scrollPane.getViewport().getView();
		
		return textPane;
	}
}
