package com.nate.hjy7942.ui.dialog;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Toolkit;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JProgressBar;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.demon.ProgressThread;
import com.nate.hjy7942.util.ResourceHandler;
import com.nate.hjy7942.util.SystemProperties;

public class ProgressDialog extends JDialog{
	
	private MainFrame mainFrame = null;
	private static ProgressDialog dialog = null;
	private static JLabel text = null;
	
	private ProgressDialog(MainFrame mainFrame){
		super(mainFrame, false);
		this.mainFrame = mainFrame;
		
		this.setUndecorated(true);
		setSize(500, 354);
		setLocation(SystemProperties.getCenterPoint(this));
		this.setResizable(false);
		
		initialize();
	}
	
	public static void showDialog(MainFrame mainFrame){
		dialog = new ProgressDialog(mainFrame);
		dialog.setVisible(true);
	}
	
	public static void disappearDialog(){
		dialog.setVisible(false);
		dialog.dispose();
	}
	
	public static void setProgressValue(int value, String textText){
		ProgressThread.setProgressValue(value);
		text.setText(textText);
	}
	
	private void initialize(){
		this.getContentPane().setLayout(null);
		
		text = new JLabel("Start...............................");
		text.setForeground(Color.WHITE);
		text.setFont(new Font(null, Font.PLAIN, 11));
		text.setBounds(10, 10, 480, 18);
		this.getContentPane().add(text);
		
		ProgressThread progressbar = new ProgressThread();
		this.getContentPane().add(progressbar);
		
		JLabel image = new JLabel(ResourceHandler.createImageIcon("index.png"));
		image.setBounds(0, 0, 500, 334);
		this.getContentPane().add(image);
		
		runProgressThread(progressbar);
	}
	
	private void runProgressThread(Runnable thread) {
		Thread runThread = new Thread(thread);
		runThread.start();
	}
}
