/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Sep 7, 2007   Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.dialog;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.conf.reader.PropertiesReader;
import com.nate.hjy7942.conf.writer.PropertiesWriter;
import com.nate.hjy7942.util.ResourceHandler;
import com.nate.hjy7942.util.SystemProperties;

/**
 * ۼ : Sep 7, 2007
 * ۼ : Ҳڹ 
 * <br>
 *  ־ ּ!!
 */
public class WorkspaceLauncherDialog extends JDialog{
	
	private MainFrame curMainFrame;
	private JDialog curDialog;
	private JTextField textField;
	private static String returnText;
		
	private WorkspaceLauncherDialog(MainFrame mainFrame) {
		super(mainFrame, true);
		this.curMainFrame = mainFrame;
		this.curDialog = this;
		getContentPane().setLayout(null);
		this.setResizable(false);
		setTitle("Workspace Launcher");
		setSize(570, 230);
		setLocation(SystemProperties.getCenterPoint(this));
		

		final JPanel panel = createPanel();
		createLabel1(panel);
		createLabel2(panel);
		createLabel3(panel);
		createWorkspaceLabel();
		createTextField();
		createBrowserButton();
		createCancelButton();
		createOkButton();
	}

	private void createOkButton() {
		final JButton okButton = new JButton();
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				returnText = textField.getText().trim();
				if(returnText == null || returnText == "" || !(new File(returnText).isDirectory())){
					JOptionPane.showMessageDialog(curDialog, "ΰ ߸ Է Ǿϴ.", "", JOptionPane.ERROR_MESSAGE);
					return;
				}
				
				String frameSetupFile = new PropertiesReader(curMainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "frameFile");
				new PropertiesWriter(curMainFrame).replacePropertyValue(frameSetupFile, "currentworkspase", returnText);
				setVisible(false);
			}
		});
		okButton.setText("OK");
		okButton.setBounds(340, 163, 103, 23);
		getContentPane().add(okButton);
	}

	private void createCancelButton() {
		final JButton cancelButton = new JButton();
		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				returnText = null;
				setVisible(false);
			}
		});
		cancelButton.setText("Cancle");
		cancelButton.setBounds(449, 163, 103, 23);
		getContentPane().add(cancelButton);
	}

	private void createBrowserButton() {
		final JButton broserButton = new JButton();
		broserButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String directory = SelectWorkspaceDirectoryDialog.showDialog(curDialog);
				if(directory != null){
					textField.setText(directory);
				}
			}
		});
		broserButton.setText("Browse..");
		broserButton.setBounds(469, 91, 83, 23);
		getContentPane().add(broserButton);
	}

	private void createTextField() {
		String frameSetupFile = new PropertiesReader(curMainFrame).getPropertyValue(ResourceHandler.getConfPath() + "setup.properties", "frameFile");
		String currentWorkSpase = new PropertiesReader(curMainFrame).getPropertyValue(frameSetupFile, "currentworkspase").trim();
		textField = new JTextField();
		textField.setText(currentWorkSpase);
		textField.setBounds(109, 92, 354, 21);
		getContentPane().add(textField);
	}

	private void createWorkspaceLabel() {
		final JLabel workspaceLabel = new JLabel();
		workspaceLabel.setFont(new Font("", Font.PLAIN, 13));
		workspaceLabel.setText("Workspace : ");
		workspaceLabel.setBounds(25, 90, 78, 24);
		getContentPane().add(workspaceLabel);
	}

	private void createLabel3(final JPanel panel) {
		final JLabel label3 = new JLabel();
		label3.setText("Choose a workspace folder to use for this session.");
		label3.setBounds(10, 45, 522, 14);
		panel.add(label3);
	}

	private JPanel createPanel() {
		final JPanel panel = new JPanel();
		panel.setLayout(null);
		panel.setBorder(new EtchedBorder(EtchedBorder.LOWERED));
		panel.setBackground(Color.WHITE);
		panel.setBounds(10, 10, 542, 69);
		getContentPane().add(panel);
		return panel;
	}

	private void createLabel1(final JPanel panel) {
		final JLabel label1 = new JLabel();
		label1.setFont(new Font("", Font.BOLD, 14));
		label1.setBounds(10, 10, 158, 14);
		label1.setText("Select a Workspace");
		panel.add(label1);
	}

	private void createLabel2(final JPanel panel) {
		final JLabel label2 = new JLabel();
		label2.setText("P_J Convertor Workbench stores your projects in a folder called a workspace.");
		label2.setBounds(10, 30, 522, 14);
		panel.add(label2);
	}
	
	public static String showDialog(MainFrame mainFrame){
		WorkspaceLauncherDialog dialog = new WorkspaceLauncherDialog(mainFrame);
		dialog.setVisible(true);
		return returnText;
	}
}
