/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 6, 2007     Ҳڹ()      Ŭ ó ۼ  
 * Aug 8, 2007     Ҳڹ()       ּ ߰, ÷  Menu  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.maker;

import java.awt.Component;
import java.lang.reflect.Constructor;
import java.util.HashMap;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;

import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.conf.reader.LoggerReader;

/**
 * ۼ : Aug 6, 2007
 * ۼ : Ҳڹ 
 * <br>
 * ޴  ִ ü
 */
public class MenuMaker {
	
	private JMenuBar menuBar = null;
	private JMenu menu = null;
	private JMenuItem menuItem = null;
	private MainFrame mainFrame = null;

	private HashMap<String, Component> menuMap = new HashMap<String, Component>();
	
	/**
	 * MenuBar ϱ  ü .
	 * @param mainFrame MenuBar  θ Frame ӹ ü
	 */
	public MenuMaker(MainFrame mainFrame){
		this.mainFrame = mainFrame;
		menuBar = new JMenuBar();
		mainFrame.setJMenuBar(menuBar);
	}
	
	/**
	 * MenuBar ϴ Լ
	 * @param nodeList Menu    ִ NodeList
	 */
	@SuppressWarnings("unchecked")
	public void makeMenuBar(NodeList nodeList){
		for(int i = 0; i < nodeList.getLength(); i++) {
			Node node = nodeList.item(i);
			if(node.getNodeName().equals("#text")) continue;
			
			if(node.getNodeName().equals("menu")) {
				if(node.hasAttributes()){
					NamedNodeMap  attrNodes = node.getAttributes();
					
					String menuName = null;
					String name = null;
					String caption = null;
					String mnemonic = null;
					String icon = null;
					String classfile = null;

					if(attrNodes.getNamedItem("menuname") != null){
						if(attrNodes.getNamedItem("menuname").getNodeValue().trim() != ""){
							menuName = attrNodes.getNamedItem("menuname").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("name") != null){
						if(attrNodes.getNamedItem("name").getNodeValue().trim() != ""){
							name = attrNodes.getNamedItem("name").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("caption") != null){
						if(attrNodes.getNamedItem("caption").getNodeValue().trim() != ""){
							caption = attrNodes.getNamedItem("caption").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("mnemonic") != null){
						if(attrNodes.getNamedItem("mnemonic").getNodeValue().trim() != ""){
							mnemonic = attrNodes.getNamedItem("mnemonic").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("icon") != null){
						if(attrNodes.getNamedItem("icon").getNodeValue().trim() != ""){
							icon = attrNodes.getNamedItem("icon").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("classfile") != null){
						if(attrNodes.getNamedItem("classfile").getNodeValue().trim() != ""){
							classfile = attrNodes.getNamedItem("classfile").getNodeValue();
						}
					}
					
					try {
						Class c = Class.forName(classfile);
						Class[] paraType = new Class[] {MainFrame.class, String.class, String.class, String.class, String.class, String.class};
						Constructor con = c.getConstructor(paraType);
						Object[] initPara = new Object[] {mainFrame, menuName, name, caption, mnemonic, icon};
						Object obj = con.newInstance(initPara);
						menu = (JMenu) obj;
						menuMap.put(menuName, menu);
						menuBar.add(menu);
					} catch (Exception e) {
						JOptionPane.showMessageDialog(mainFrame, "޴  Ҵ翡  ߽ϴ.", "", JOptionPane.ERROR_MESSAGE);
						LoggerReader.getLogger(mainFrame).fatal("޴  Ҵ翡  ߽ϴ. (" + e.getMessage() + ")");
						System.exit(0);
					}
				}
				
				if(node.hasChildNodes()){
					addMenuFromXml(node.getChildNodes(), menu);		
				}
			}
		}
		
		mainFrame.setMenuMap(menuMap);
	}
	
	/**
	 * Menu ٽ Menu, MenuItem ߰ϱ  Լ
	 * @param nodeList Menu  Menu    NodeList
	 * @param menu NodeList Menu MenuItem ٱ  θ Menu
	 */
	@SuppressWarnings("unchecked")
	private void addMenuFromXml(NodeList nodeList, JMenu menu){
		JMenu tempMenu = null;
		
		for(int i = 0; i < nodeList.getLength(); i++){
			Node node = nodeList.item(i);
			
			if(node.getNodeName().equals("#text")) continue;
			
			if(node.getNodeName().equals("menu")){
				if(node.hasAttributes()){
					NamedNodeMap  attrNodes = node.getAttributes();
					
					String menuName = null;
					String name = null;
					String caption = null;
					String mnemonic = null;
					String icon = null;
					String classfile = null;
					
					if(attrNodes.getNamedItem("menuname") != null){
						if(attrNodes.getNamedItem("menuname").getNodeValue().trim() != ""){
							menuName = attrNodes.getNamedItem("menuname").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("name") != null){
						if(attrNodes.getNamedItem("name").getNodeValue().trim() != ""){
							name = attrNodes.getNamedItem("name").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("caption") != null){
						if(attrNodes.getNamedItem("caption").getNodeValue().trim() != ""){
							caption = attrNodes.getNamedItem("caption").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("mnemonic") != null){
						if(attrNodes.getNamedItem("mnemonic").getNodeValue().trim() != ""){
							mnemonic = attrNodes.getNamedItem("mnemonic").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("icon") != null){
						if(attrNodes.getNamedItem("icon").getNodeValue().trim() != ""){
							icon = attrNodes.getNamedItem("icon").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("classfile") != null){
						if(attrNodes.getNamedItem("classfile").getNodeValue().trim() != ""){
							classfile = attrNodes.getNamedItem("classfile").getNodeValue();
						}
					}
					
					try {
						Class c = Class.forName(classfile);
						Class[] paraType = new Class[] {MainFrame.class, String.class, String.class, String.class, String.class, String.class};
						Constructor con = c.getConstructor(paraType);
						Object[] initPara = new Object[] {mainFrame, menuName, name, caption, mnemonic, icon};
						Object obj = con.newInstance(initPara);
						tempMenu = (JMenu) obj;
						menuMap.put(menuName, tempMenu);
						menu.add(tempMenu);
					} catch (Exception e) {
						JOptionPane.showMessageDialog(mainFrame, "޴  Ҵ翡  ߽ϴ.", "", JOptionPane.ERROR_MESSAGE);
						LoggerReader.getLogger(mainFrame).fatal("޴  Ҵ翡  ߽ϴ. (" + e.getMessage() + ")");
						System.exit(0);
					}
				}
				
				if(node.hasChildNodes()){
					addMenuFromXml(node.getChildNodes(), tempMenu);		
				}
			}
			
			if(node.getNodeName().equals("menuitem")){
				if(node.hasAttributes()){
					NamedNodeMap  attrNodes = node.getAttributes();
					
					String menuName = null;
					String name = null;
					String caption = null;
					String accelerator = null;
					String icon = null;
					String classfile = null;
					
					if(attrNodes.getNamedItem("menuname") != null){
						if(attrNodes.getNamedItem("menuname").getNodeValue().trim() != ""){
							menuName = attrNodes.getNamedItem("menuname").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("name") != null){
						if(attrNodes.getNamedItem("name").getNodeValue().trim() != ""){
							name = attrNodes.getNamedItem("name").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("caption") != null){
						if(attrNodes.getNamedItem("caption").getNodeValue().trim() != ""){
							caption = attrNodes.getNamedItem("caption").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("accelerator") != null){
						if(attrNodes.getNamedItem("accelerator").getNodeValue().trim() != ""){
							accelerator = attrNodes.getNamedItem("accelerator").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("icon") != null){
						if(attrNodes.getNamedItem("icon").getNodeValue().trim() != ""){
							icon = attrNodes.getNamedItem("icon").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("classfile") != null){
						if(attrNodes.getNamedItem("classfile").getNodeValue().trim() != ""){
							classfile = attrNodes.getNamedItem("classfile").getNodeValue();
						}
					}
					
					try {
						Class c = Class.forName(classfile);
						Class[] paraType = new Class[] {MainFrame.class, String.class, String.class, String.class, String.class, String.class};
						Constructor con = c.getConstructor(paraType);
						Object[] initPara = new Object[] {mainFrame, menuName, name, caption, accelerator, icon};
						Object obj = con.newInstance(initPara);
						menuItem = (JMenuItem) obj;
						menuMap.put(menuName, menuItem);
						menu.add(menuItem);
					} catch (Exception e) {
						JOptionPane.showMessageDialog(mainFrame, "޴  Ҵ翡  ߽ϴ.", "", JOptionPane.ERROR_MESSAGE);
						LoggerReader.getLogger(mainFrame).fatal("޴  Ҵ翡  ߽ϴ. (" + e.getMessage() + ")");
						System.exit(0);
					}
				}			
			}
			
			if(node.getNodeName().equals("separator")) {
				menu.addSeparator();
			}
		}		
	}
	
	/**
	 *  ϰ  ޴  ϴ Լ̴.
	 * xmlϿ ϰ  Menu, MenuItem menuName Ӽ  ְ Ǹ, 
	 * Ȱ  ϴ Menu Ǵ MenuItem   ް ȴ.
	 *  ޴  Component̰, ̰ ٿ ĳϿ ϰ ϴ JMenu JMenuItem ȯϿ Ѵ.
	 * 
	 * ex > mainFrame.getProgramMenuBar().add(MakeMenu.getMenu("File");
	 *       ̷ ϸ File޴  ұ ǿ ޴  ٰ ȴ.
	 *       
	 * Ķʹ menubar.xml  Ͽ, ش ޴ menuName Ӽ   ȴ.
	 * 
	 * @param menuName menuӼ menuName Ӽ .
	 * @return Componentü  , JMenu Ǵ JMenuItem ĳ Ͽ  .
	 */
	public static Component getCreateMenu(MainFrame mainFrame, String menuName){
		return MenuCreator.getMenu(mainFrame, menuName);
	}
	
	/**
	 * menuName شϴ ޴  ִ Լ̴.
	 * ⼭  ޴ Ǿ ϵǴ° ƴ϶ ٸ  ؼ ȵȴ.
	 *  ٸ Լ ȣϿ  ޴  ־.. ޴ٿ ش ޴  ȴ.
	 * 
	 * @param menuName menuӼ menuName Ӽ .
	 * @return Componentü  , JMenu Ǵ JMenuItem ĳ Ͽ  .
	 */
	public static Component getMenu(MainFrame mainFrame, String menuName) {
		return MenuGetter.getMenu(mainFrame, menuName);
	}
}
