/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ******************************
 *                             
 * [¥]           [۾]           []
 * Aug 15, 2007  Ҳڹ          Ŭ ó ۼ  
 * 
 *************************************************************************
 */

package com.nate.hjy7942.ui.maker;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.lang.reflect.Constructor;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

import javax.swing.JMenu;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JToolBar;

import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.conf.reader.LoggerReader;
import com.nate.hjy7942.ui.menu.ToolBarMenuItem;
import com.nate.hjy7942.util.ResourceHandler;

/**
 * ۼ : Aug 15, 2007
 * ۼ : Ҳڹ 
 * <br>
 * α׷ ٸ ִ ü.
 */
public class ToolBarMaker {
	
	private MainFrame mainFrame = null;
	private JToolBar toolBar = null;
	private JPanel panel = null;
	
	private HashMap<String, Component> toolBarMap = new HashMap<String, Component>();

	/**
	 * ToolBar ϱ  ü .
	 * @param mainFrame ToolBar  θ Frame ӹ ü
	 */
	public ToolBarMaker(MainFrame mainFrame){
		this.mainFrame = mainFrame;
		
		panel = new JPanel();
		panel.setLayout(new FlowLayout(FlowLayout.LEFT));
		panel.setPreferredSize(new Dimension(0, 32));
		mainFrame.setPanelNorth(panel);
		
		mainFrame.getContentPane().add("North", panel);
	}
	
	/**
	 * ToolBar ϴ Լ
	 * @param nodeList ToolBar    ִ NodeList
	 */
	@SuppressWarnings("unchecked")
	public void makeToolBar(NodeList nodeList){
		for(int i = 0; i < nodeList.getLength(); i++) {
			Node node = nodeList.item(i);
			if(node.getNodeName().equals("#text")) continue;
			
			if(node.getNodeName().equals("toolbaritem")) {
				if(node.hasAttributes()){
					NamedNodeMap  attrNodes = node.getAttributes();
					
					String name = null;
					String enable = null;
					String borderpainted = null;
					String floatable = null;
					String classfile = null;
					
					if(attrNodes.getNamedItem("name") != null){
						if(attrNodes.getNamedItem("name").getNodeValue().trim() != ""){
							name = attrNodes.getNamedItem("name").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("enable") != null){
						if(attrNodes.getNamedItem("enable").getNodeValue().trim() != ""){
							enable = attrNodes.getNamedItem("enable").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("borderpainted") != null){
						if(attrNodes.getNamedItem("borderpainted").getNodeValue().trim() != ""){
							borderpainted = attrNodes.getNamedItem("borderpainted").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("floatable") != null){
						if(attrNodes.getNamedItem("floatable").getNodeValue().trim() != ""){
							floatable = attrNodes.getNamedItem("floatable").getNodeValue();
						}
					}
					if(attrNodes.getNamedItem("classfile") != null){
						if(attrNodes.getNamedItem("classfile").getNodeValue().trim() != ""){
							classfile = attrNodes.getNamedItem("classfile").getNodeValue();
						}
					}
					
					try {
						Class c = Class.forName(classfile);
						Class[] paraType = new Class[] {MainFrame.class, String.class, String.class, String.class};
						Constructor con = c.getConstructor(paraType);
						Object[] initPara = new Object[] {mainFrame, name, borderpainted, floatable};
						Object obj = con.newInstance(initPara);
						toolBar = (JToolBar) obj;
						toolBarMap.put(name, toolBar);
						panel.add(toolBar);
						if(!Boolean.valueOf(enable)){
							toolBar.setVisible(false);
						}
					} catch (Exception e) {
						JOptionPane.showMessageDialog(mainFrame, "  Ҵ翡  ߽ϴ.", "", JOptionPane.ERROR_MESSAGE);
						LoggerReader.getLogger(mainFrame).fatal("  Ҵ翡  ߽ϴ. (" + e.getMessage() + ")");
						System.exit(0);
					}
				}
			}
		}
		
		mainFrame.setToolBarMap(toolBarMap);
		addToolBarMenu();
	}
	
	private void addToolBarMenu(){
		JMenu menu = (JMenu) MenuMaker.getMenu(mainFrame, "WindowToolBar");
		Set<String> toolBarSet = toolBarMap.keySet();
		Iterator<String> iter = toolBarSet.iterator();
		
		while(iter.hasNext()){
			JToolBar toolBar = (JToolBar) toolBarMap.get(iter.next());
			if(toolBar.isVisible()) {
				menu.add(new ToolBarMenuItem(mainFrame, toolBar.getName(), ResourceHandler.createImageIcon("check.gif"), true));
			}
			else {
				menu.add(new ToolBarMenuItem(mainFrame, toolBar.getName(), ResourceHandler.createImageIcon("check.gif"), false));
			}
		}
	}
}
