/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ****************************
 *                             
 * [¥]         [۾]             []
 * 2007. 09. 01   Ҳڹ          Ŭ ó ۼ  
 * 
 ********************************************************************
 */

package com.nate.hjy7942.ui.tabmodule;

import javax.swing.tree.DefaultMutableTreeNode;

/**
 * ۼ : 2007. 09. 01
 * ۼ : Ҳڹ 
 * <br>
 * JTree Ǵ  Connection  ϴ Node Ŭ<br>
 */
public class ConnectionNode {
	
	public static final String[] nodeNames = {
			"Tables", "Views", "Indexes", "Packages",
			"Procedures", "Functions", "Triggers",
			"Types", "Sequences", "Materialized Views",
			"Materialized Views Logs", "Synonyms",
			"Public Synonyms", "Database Links", "Public Database Links"
			, "Directories", "XML Schemas", "Recycle Bin", "Other Users" };

	private String nodeName;
	
	/**
	 * Ŀؼ ĺ  ִ ̸ ޾ δ. 
	 * @param nodeName
	 */
	public ConnectionNode(String nodeName) {
		this.nodeName = nodeName;
		initialize();
	}
	
	// Ŀؼ ֻ 
	private DefaultMutableTreeNode connectionNode;
	
	public ConnectionNode() {
		initialize();
	}
	
	private void initialize() {
		buildConnectionNode();
	}
	
	
	private void buildConnectionNode() {
		// ֻ    ű⿡  ͺ̽ ü ߰Ѵ. 
		connectionNode = new DatabaseRootNode(nodeName);
		
		for(int i=0; i<nodeNames.length; i++) {
			DefaultMutableTreeNode childNode = new DatabaseObjectNode( nodeNames[i] );
			connectionNode.add(childNode);
		}
	}
	
	
	/**
	 * Ŀؼ ֻ  Ѵ. 
	 * @return
	 */
	public DefaultMutableTreeNode getConnectionNode() {
		return connectionNode;
	}
	
	public String toString() {
		return nodeName;
	}

	
	/**
	 * 
	   * ۼ : 2007. 09. 08
	   * ۼ : Ҳڹ 
	   * <br>
	   * ͺ̽ ü   ĺϴ ֻ ߻Ŭ<br>
	 */
	static abstract class AbstractDatabaseNode extends DefaultMutableTreeNode {
		
		protected String name;
		
		public AbstractDatabaseNode() { this(""); }

		public AbstractDatabaseNode(Object obj) {
			this.name = obj.toString();
		}

		public String getName() {
			return name;
		}
		
		public String toString() {
			return name;
		}
	}
	
	/**
	 * 
	   * ۼ : 2007. 09. 08
	   * ۼ : Ҳڹ 
	   * <br>
	   * ͺ̽ ü(Table, View, Trigger, Procedure...) ǥϴ  Ŭ
	 */
	static final class DatabaseObjectNode extends AbstractDatabaseNode {

		public DatabaseObjectNode(String name) {
			super(name);
		}
		
	}
	
	
	/**
	 * 
	   * ۼ : 2007. 09. 08
	   * ۼ : Ҳڹ 
	   * <br>
	   * Ŀؼ ֻ Ÿ 
	 */
	static final class DatabaseRootNode extends AbstractDatabaseNode {
		
		public DatabaseRootNode(String name) {
			super(name);
		}
		
		public String getName() {
			return "database";
		}
		
		public String toString() {
			return name;
		}
		
		
		
	}
	
	
}
