/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ****************************
 *                             
 * [¥]         [۾]             []
 * 2007. 09. 08   Ҳڹ          Ŭ ó ۼ  
 * 
 ********************************************************************
 */

package com.nate.hjy7942.ui.tabmodule;

import java.awt.Component;
import java.util.HashMap;
import java.util.Map;

import javax.swing.ImageIcon;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellRenderer;

import com.nate.hjy7942.ui.tabmodule.ConnectionNode.AbstractDatabaseNode;
import com.nate.hjy7942.util.ResourceHandler;

/**
 * ۼ : 2007. 09. 08
 * ۼ : Ҳڹ 
 * <br>
 * Connection Tree    ϴ Ŭ
 */
class ConnectionNodeRenderer extends DefaultTreeCellRenderer {
	
	private Map<String, ImageIcon> iconMap;
	private final String imageExtender = ".png";
	private final String suffix = "_folder";
	
	/**
	 *  ϱ  ̹ ü ̸ ҷͼ ʿ Ѵ. 
	 *  Ű ConnectionNode.nodeNames ǵǾ ִ. 
	 */
	private void initialize() {
		iconMap = new HashMap<String, ImageIcon>();
		
		for(int i=0; i<ConnectionNode.nodeNames.length; i++) {
			iconMap.put(ConnectionNode.nodeNames[i], 
					ResourceHandler.createImageIcon(ConnectionNode.nodeNames[i] + suffix + imageExtender));
		}
		
		// ͺ̽ ü ƴ ͵  Ǿ . . 
		iconMap.put("Connections", ResourceHandler.createImageIcon("Connection" + imageExtender));
		iconMap.put("database", ResourceHandler.createImageIcon("database" + imageExtender));
		
	}
	
	public ConnectionNodeRenderer() {
		initialize();
	}

	@Override
	public Component getTreeCellRendererComponent(JTree tree, Object value,
			boolean sel, boolean expanded, boolean leaf, int row,
			boolean hasFocus) {
		
		super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf,
				row, hasFocus);

		if(value instanceof AbstractDatabaseNode) {
			AbstractDatabaseNode node = (AbstractDatabaseNode) value;
			if( !isValidNodeName( node.getName() ) ) {
				return null;
			}
			setIcon(iconMap.get(node.getName()));
		}
			
		return this;
		
	}
	
	/**
	 * ͺ̽ ü   Ʈ Ÿ ̸ ˻Ѵ. 
	 * @param nodeName
	 * @return
	 */
	private boolean isValidNodeName(String nodeName) {
		for(int i=0; i<ConnectionNode.nodeNames.length; i++) {
			if( nodeName.equals(ConnectionNode.nodeNames[i])) {
				return true; 
			} 
		}
		return (isRootNode(nodeName)) ? true : false;
	}
	
	/**
	 * Ʈ  ̸  ǴѴ. 
	 * @param nodeName
	 * @return
	 */
	private boolean isRootNode(String nodeName) {
		String[] nodeNames = {"database", "Connections"}; 
		for(int i=0; i<nodeNames.length; i++) {
			if(nodeNames[i].equals(nodeNames[i])) {
				return true;
			}
		}
		return false;
	}
	
	ImageIcon getImage(String key) {
		return iconMap.get(key);
	}
}
