/*
 * @author Ҳڹ 
 *
 ********************* [ڵ  丮] ****************************
 *                             
 * [¥]         [۾]             []
 * 2007. 09. 18   Ҳڹ()          Ŭ ó ۼ  
 * 
 ********************************************************************
 */

package com.nate.hjy7942.ui.tabmodule;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Iterator;
import java.util.Set;

import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;

import com.nate.hjy7942.conf.manager.MainFrame;
import com.nate.hjy7942.database.DatabaseConnectionHandler;
import com.nate.hjy7942.database.DatabaseConnectionManager;
import com.nate.hjy7942.ui.DatabaseConnectionView;
import com.nate.hjy7942.ui.maker.MenuMaker;
import com.nate.hjy7942.ui.menu.listener.DatabaseNewConnectionListener;
import com.nate.hjy7942.ui.tabmodule.ConnectionNode.AbstractDatabaseNode;

/**
 * ۼ : 2007. 09. 18
 * ۼ : Ҳڹ() 
 * <br>
 *  ־ ּ!!
 */
public class DatabaseConnectionTree implements DatabaseConnectionView {
	
	private JTree connectionsTree;
	private MainFrame mainFrame;
	private ConnectionRootNode rootNode;
	private DatabaseConnectionManager dbConnectionManager;
	
	DatabaseConnectionTree(MainFrame mainFrame, DatabaseConnectionManager dbConnectionManager) {
		this.dbConnectionManager = dbConnectionManager;
		dbConnectionManager.addView(this);
		this.mainFrame = mainFrame;
		initializeConnectionTree();
	}
	
	private void initializeConnectionTree() {
		rootNode = new ConnectionRootNode();
		
		connectionsTree = new JTree(rootNode);
		connectionsTree.addMouseListener(new ConnectionsTreeMouseListener());
		connectionsTree.setCellRenderer(new ConnectionNodeRenderer());

		
		Set keys = dbConnectionManager.keySet();
		for(Iterator each = keys.iterator(); each.hasNext();) {
			String nodeName = (String) each.next();
			addConnectionNode(new ConnectionNode(nodeName));
		}
		
	}
	
	private class ConnectionRootNode extends AbstractDatabaseNode {
		static final String NODE_NAME = "Connections";

		public ConnectionRootNode() {
			super(NODE_NAME);
		}
	}
	
	public JTree getTree() {
		return connectionsTree;
	}
	/**
	 * ConnectionNode ߰Ѵ. ߰  connectionTree Ÿ.
	 * @param node
	 */
	void addConnectionNode(ConnectionNode node) {
		rootNode.add(node.getConnectionNode());
		DefaultTreeModel rootNodeModel = (DefaultTreeModel) connectionsTree.getModel();
		rootNodeModel.reload(rootNode);
	}
	
	private class ConnectionsTreeMouseListener extends MouseAdapter {
		private JPopupMenu jPopupMenu;
		
		ConnectionsTreeMouseListener() {
			initializePopupMenu();
		}
		private void initializePopupMenu() {
			jPopupMenu = new JPopupMenu();
			JMenu newConnection = (JMenu) MenuMaker.getCreateMenu(mainFrame, "Database");
			newConnection.addActionListener(DatabaseNewConnectionListener.getInstance(mainFrame));

			java.awt.Component[] menuComponents = newConnection.getMenuComponents();
			for(int i=0; i<menuComponents.length; i++) {
				jPopupMenu.add((JMenuItem) menuComponents[i]);
			}
		}
		@Override
		public void mousePressed(MouseEvent me) {
			if(me.getButton() == MouseEvent.BUTTON3) {
				int selRow = connectionsTree.getRowForLocation(me.getX(), me.getY());
				TreePath selPath = connectionsTree.getPathForLocation(me.getX(), me.getY());
				if(selRow != -1) {
					if(selPath.getLastPathComponent() != null) {
						if( ConnectionRootNode.NODE_NAME.equals(selPath.getLastPathComponent().toString()) ) {
							jPopupMenu.show(me.getComponent(),
									me.getX(), me.getY());	
						}
					} 
				}  
				
			}
		}
			 
	}

	public void addConnectionHandler(DatabaseConnectionHandler handler) {
		addConnectionNode( new ConnectionNode(handler.getKey()) );
	}

	public void updateUI() {
		initializeConnectionTree();
		
	}


	

}
